TEMPLATE	= app
CONFIG		= qt thread dll warn_on release
HEADERS		= src/CoTeXTool.h \
                  ui/CoTeXConfigurationWidget.h \
                  ui/TextureConfigurationWidget.h \
                  ui/AbstractConfigurationWidget.h \
                  ui/ColorConfigurationWidget.h \
                  ui/PerlinNoiseConfigurationWidget.h \
                  ui/ConvConfigurationWidget.h \
                  ui/RBFConfigurationWidget.h \
                  ui/UITools/DoubleSpinBox.h \
                  src/Interfaces/CoTeXNode.h \
                  src/Interfaces/CoTeXTreeInterface.h \
                  src/Interfaces/OperatorInterface.h \
                  src/Interfaces/PrimitiveInterface.h \
                  src/Interfaces/TextureInterface.h \
                  src/Interfaces/AttributeInterface.h \
                  src/Interfaces/HyperFunable.h \
                  src/Interfaces/Savable.h \
                  src/Interfaces/PrimitiveManagerInterface.h \
                  src/Interfaces/OperatorManagerInterface.h \
                  src/Operators/OperatorUnion.h \
                  src/Operators/OperatorUnionManager.h \
                  src/ColorCoTeXTree/ColorCoTeXTree.h \
                  src/Attributes/ColorAttribute.h \
                  src/Primitives/Sphere.h \
                  src/Textures/SimpleColorTexture.h \
                  src/Textures/PerlinNoiseColorTexture.h \
                  src/Textures/PerlinNoise.h \
                  src/Primitives/SphereManager.h \
                  src/Primitives/ConvPointManager.h \
                  src/Primitives/ConvPoint.h \
                  src/Primitives/RbfManager.h \
                  src/Primitives/Rbf.h \
                  src/Primitives/Block.h \
                  src/Primitives/BlockManager.h \
                  src/Primitives/LinearSolver.h \
                  src/SurfelGenerator/SurfelGenerator.h \
                  src/SurfelGenerator/Polygonizer/hfpolymesh.h \
                  src/CoTeXIO/CoTeXIO.h \
                  src/BBoxMinMax/BBoxMinMax.h

SOURCES		= src/CoTeXTool.cpp \
                  ui/CoTeXConfigurationWidget.cpp \
                  ui/TextureConfigurationWidget.cpp \
                  ui/AbstractConfigurationWidget.cpp \
                  ui/ColorConfigurationWidget.cpp \
                  ui/PerlinNoiseConfigurationWidget.cpp \
                  ui/ConvConfigurationWidget.cpp \
                  ui/RBFConfigurationWidget.cpp \
                  ui/UITools/DoubleSpinBox.cpp \
                  src/Interfaces/CoTeXTreeInterface.cpp \
                  src/Interfaces/CoTeXNode.cpp \
                  src/Interfaces/PrimitiveInterface.cpp \
                  src/Interfaces/TextureInterface.cpp \
                  src/Interfaces/AttributeInterface.cpp \
                  src/Interfaces/OperatorInterface.cpp \
                  src/Interfaces/PrimitiveManagerInterface.cpp \
                  src/Operators/OperatorUnion.cpp \
                  src/Operators/OperatorUnionManager.cpp \
                  src/ColorCoTeXTree/ColorCoTeXTree.cpp \
                  src/Attributes/ColorAttribute.cpp \
                  src/Primitives/Sphere.cpp \
                  src/Textures/SimpleColorTexture.cpp \
                  src/Textures/PerlinNoiseColorTexture.cpp \
                  src/Textures/PerlinNoise.cpp \
                  src/Primitives/SphereManager.cpp \
                  src/Primitives/ConvPointManager.cpp \
                  src/Primitives/ConvPoint.cpp \
                  src/Primitives/RbfManager.cpp \
                  src/Primitives/Rbf.cpp \
                  src/Primitives/Block.cpp \
                  src/Primitives/BlockManager.cpp \
                  src/Primitives/LinearSolver.cpp \
                  src/SurfelGenerator/SurfelGenerator.cpp \
                  src/SurfelGenerator/Polygonizer/hfpolymesh.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_addface.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_normalsearch.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_calc.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_refine.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_createnormals.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_storecell.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_createtriangles.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_tracegraph.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_fillindex.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_tridata.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_fillmatrix.cpp \     
                  src/SurfelGenerator/Polygonizer/hfpm_fillvertices.cpp \
                  src/SurfelGenerator/Polygonizer/hfpm_graphbuild.cpp \
                  src/CoTeXIO/CoTeXIO.cpp
           

INTERFACES	= 

ALL_DEPS	=

TMAKE_CXXFLAGS  = 

DISTFILES       = README \
                  Doxyfile \
                  Makefile \
                  Resources/CoTeXToolIcon.png \
                  Resources/CoTeXIcon.png \
                  Resources/CoTeXToolIcon_disabled.png \
                  Resources/CoTeXRbfIcon.png \
                  Resources/CoTeXBlockIcon.png \
                  Resources/CoTeXSphereIcon.png \
                  Resources/CoTeXConvolutionIcon.png \
                  Resources/CoTeXPerlinNoiseIcon.png \
                  Resources/CoTeXColorIcon.png \
                  Resources/CoTeXUnionIcon.png \
                  CoTeXTool.dsp

TARGET		= CoTeXTool

INCLUDEPATH     = ../../../Core/Scene/src \
                  ../../../Core/RendererManager/src \
                  ../../../Core/Transformer/src \
                  ../../../Core/Interfaces/src \
                  ../../../Utilities/UserMessages/src/ \
                  ../../../Utilities/src/ \
                  ../../../DataTypes/src 

OBJECTS_DIR     = bin/linux/Release

MOC_DIR		= bin/linux/Release

DESTDIR		= ../../../../bin/linux/Release/Tools

unix:LIBS	+= -L../../../../bin/linux/Release -lCore -lDataTypes -lUtilities

