#ifndef ATTRIBUTEINTERFACE_H
#define ATTRIBUTEINTERFACE_H

#include "../../../../../Core/Scene/src/Scene.h"


/// The base classe for all attributes used in CoTeX.
class AttributeInterface{
public :
  
  /// Describe the action of the attribute on a surfel
  /**
   * This method must implements the modification of the surfels properties : 
   *  - color (diffuse, specular, etc...)
   *  - position
   *  - etc ...
   *
   * @param surfel the surfel to modify.
   * @param scene the scene used.
   * @param repaint redraw the scene if true.
   */
  virtual void affectSurfel (SurfelInterface * surfel, Scene * scene, bool repaint) const = 0;

  static void printDebug (); 

};

#endif // ATTRIBUTEINTERFACE_H
