
#include "hfpolymesh.h"

void HFPolyMesh::Refinement(){

int i;
	int N=0;
	int V=itsData.getNumV();

	vector<double> normal(3,0.0);
	vector<double> vertex(3,0.0);
	double val=0.0;
	for(i=0;i<V;i++){
		val=itsData.getVal(i);
		if(val<0.0) N++;
	
	}

	vector<double> limit(3,0.0);
	vector<double> step(3,0.0);
	
	/**Used for the second method*/
	vector<double> tmp(3,0.0);
	vector< vector < double > > cube(8+6+1,tmp);
	//*Starts with the 8 vertices of the corners
	//*Then 6 vertives in the middle of each side 
	//*of the cube
	double z = 1;
	for(i=0;i<2;i++){
	
		cube[i*4+0][0] = -1.0;
		cube[i*4+0][1] = -1.0;
		
		cube[i*4+1][0] = 1.0;
		cube[i*4+1][1] = -1.0;
		
		cube[i*4+2][0] = 1.0;
		cube[i*4+2][1] = 1.0;

		cube[i*4+3][0] = -1.0;
		cube[i*4+3][1] = 1.0;

		for(int j=0;j<4;j++)
			cube[i*4+j][2]=z;
		z=-1;
	}
	cube[8][0]=1.0;
	cube[9][1]=1.0;
	cube[10][2]=1.0;

	cube[11][0]=-1.0;
	cube[12][1]=-1.0;
	cube[13][2]=-1.0;


	
	for(i=0;i<3;i++){
		limit[i] = itsDelta[i]/1.5;///This is strange. It should be delta*0.5...but does not work
		step[i] =  itsDelta[i]/(double)itsRefinement;
	}
	std::cout<<"Number of vertex to refine :"<<N<<endl;
	int NN=0;
	int found1=0;
	int found2=0;
	for(i=0;i<V;i++){
		val=itsData.getVal(i);
		if(val<0.0) {
			NN++;
			normal=itsData.getNormal(i);
			vertex=itsData.getVertex(i);
			if(FindPositiveValue1(&vertex,normal,step,limit)==1){
				found1++;
				///////////TO DO : CHANGE THE NORMAL !!!
				//*****But it does not work. So I do not change neither the vertex nor 
				//*****the normal.
				//itsData.ReplaceVertex(i,vertex,val,itsSAttributes);
				//CalcNormal(i,&normal);
				//itsData.setNormal(i,normal);
				itsData.setAttributes(i,itsSAttributes);
			}
			else if(FindPositiveValue2(&vertex,step,cube,limit)==1){ 
				itsData.setAttributes(i,itsSAttributes);
				found2++;
			
			}

		std::cout<<"\b\b\b\b\b\b\b\b\b\b\b\b\b\b"<<NN<<"/"<<N;
		}
	
	}
	std::cout<<endl;
	std::cout<<"First Method :"<<found1<<endl;
	std::cout<<"Second Method :"<<found2<<endl;
	std::cout<<"Both mehods :"<<found1<<"+"<<found2<<"="<<found1+found2<<endl;
	std::cout<<"Difference :"<<N-(found1+found2)<<endl;


}

int HFPolyMesh::FindPositiveValue1(vector<double> *vertex,vector<double> normal,
								  vector<double> step,  vector<double> limit){
int i;	
/***Search of the closest vertex with a positive function
/***Along the normal*/
	double copy_p[3];
	double copy_n[3];
	double v1,v2;
	if((step[0]>limit[0])&&(step[1]>limit[1])&&(step[2]>limit[2]))
				return 0;
	if((normal[0]==0.0)&&(normal[1]==0.0)&&(normal[2]==0.0))
				return 0;
	
	for(i=0;i<3;i++){
		copy_p[i]=(*vertex)[i]+step[i]*normal[i];
		copy_n[i]=(*vertex)[i]-step[i]*normal[i];
	}

	v1 = CalcVal(copy_p);
	if(v1<itsS0){
		v2 = CalcVal(copy_n);
		if(v2<itsS0) {
			for(int j=0;j<3;j++)  step[j]=step[j]+itsDelta[j]/(double)itsRefinement;
			return FindPositiveValue1(vertex,normal,step,limit);
		}
		else {
			for(i=0;i<3;i++){
				(*vertex)[i]=copy_n[i];
			}
			return 1;
		}	
	}
	else {
			for(i=0;i<3;i++){
				(*vertex)[i]=copy_p[i];
			}
			return 1;
		}	
	
	return 0;

}

int HFPolyMesh::FindPositiveValue2(vector<double> *vertex,vector<double> step,vector< vector<double> > cube,vector<double> limit){
/***Search of the closest vertex with a positive function
/***Refinement of the cell
/***Its size is given by itsDelta
/***The cell is centered around vertex.*/
/***Notice about the parameter cube : This functionmay become recursive. Useless
/***to calculate severam times the cube vector,so it is set as parameters
/***add contains only 1 , 0 or -1.*/

	double copy[3];
	double val;
int i,j;
			 /*14=8+6 from the cube*/
	
	if((step[0]>limit[0])&&(step[1]>limit[1])&&(step[2]>limit[2]))
				return 0;

	for(i=0;i<14;i++){
		for(j=0;j<3;j++)
			copy[j]=(*vertex)[j]+cube[i][j]*step[j];
	
		val = CalcVal(copy);
		if(val>itsS0) {i=14;j=3;return 1;};

	}

	for(i=0;i<3;i++)
		step[i] += itsDelta[i]/(double)itsRefinement;
	return FindPositiveValue2(vertex,step,cube,limit);
}
