#include <qlabel.h>
#include <qlayout.h>
#include <qstring.h>

#include "ConvConfigurationWidget.h"

static const double CONV_S_MIN = 0.50;
static const double CONV_S_MAX = 10.0;
static const double CONV_S_STEP = 0.1;
static const int CONV_S_NB_DEC = 2;
static const double CONV_S_DEFAULT_VALUE = 1.0;
static const double CONV_THRESHOLD_MIN = 0.00001;
static const double CONV_THRESHOLD_MAX = 0.1;
static const double CONV_THRESHOLD_STEP = 0.001;
static const int CONV_THRESHOLD_NB_DEC = 6;
static const double CONV_THRESHOLD_DEFAULT_VALUE = 0.00001;

ConvConfigurationWidget::ConvConfigurationWidget (QWidget * parent)
  : QWidget (parent) {
  
  QLabel * convSLabel = new QLabel ("S : ", this);
  convSDbSpinBox = new DoubleSpinBox (CONV_S_MIN, CONV_S_MAX, CONV_S_NB_DEC, CONV_S_STEP,
				      CONV_S_DEFAULT_VALUE, this);
  convSValidator = new QDoubleValidator (CONV_S_MIN, CONV_S_MAX, CONV_S_NB_DEC, this);  
  convSDbSpinBox->setValidator (convSValidator);

  QLabel * convThresholdLabel = new QLabel ("Threshold : ", this);
  convThresholdDbSpinBox = new DoubleSpinBox (CONV_THRESHOLD_MIN, CONV_THRESHOLD_MAX,
					      CONV_THRESHOLD_NB_DEC, CONV_THRESHOLD_STEP, 
					      CONV_THRESHOLD_DEFAULT_VALUE, this);
  convThresholdValidator = new QDoubleValidator (CONV_THRESHOLD_MIN, CONV_THRESHOLD_MAX,
						 CONV_THRESHOLD_NB_DEC, this);
  convThresholdDbSpinBox->setValidator (convThresholdValidator);
  
  QGridLayout * convGridLayout = new QGridLayout (this, 2, 2);
  convGridLayout->addWidget (convSLabel, 0, 0);
  convGridLayout->addWidget (convSDbSpinBox, 0, 1);
  convGridLayout->addWidget (convThresholdLabel, 1, 0);
  convGridLayout->addWidget (convThresholdDbSpinBox, 1, 1);
  convGridLayout->activate ();
}
