#ifndef CONVCONFIGURATIONWIDGET_H
#define CONVCONFIGURATIONWIDGET_H

#include <qvalidator.h>

#include "UITools/DoubleSpinBox.h"

/// Class for the widget of configuration of the primitive 'convolution'
/**
 * This widget allows to do the settings of the primitive 'convolution'.
 */
class ConvConfigurationWidget : public QWidget {
  
  Q_OBJECT
  
public:

  /// The constructor
  ConvConfigurationWidget (QWidget * parent = NULL);

  /// The destructor
  virtual ~ConvConfigurationWidget () {}

  // ********
  // Services
  // ********
  
  inline double getS () const { return convSDbSpinBox->value ();}
  inline double getThreshold () const { return convThresholdDbSpinBox->value ();}
 
private:

  DoubleSpinBox * convSDbSpinBox; ///< the SpinBox where the parameter 's' is configure 
  DoubleSpinBox * convThresholdDbSpinBox; ///< the SpinBox where the parameter 'threshold' is configure 
  QDoubleValidator * convSValidator;
  QDoubleValidator * convThresholdValidator;
};

#endif // CONVCONFIGURATIONWIDGET_H
